<template>
  <div class="event-data">
    <hr />

    <div class="columns is-centered is-vcentered">
      <div class="column">
        <available-date v-on:dateChanged="dateChanged" />
      </div> <!-- column -->
      <div class="column">
        <available-time
          :key="availableTimeKey"
          :dateChoosed="dateChoosed"
          :allDates="allDates"
          v-if="dateChoosed"
          v-on:timeChanged="timeChanged" />
      </div> <!-- column -->
    </div> <!-- columns -->
  </div>
</template>

<script>
import AvailableDate from '@/views/Agenda/components/AvailableDate'
import AvailableTime from '@/views/Agenda/components/AvailableTime'

export default {
  name: 'EventData',
  props: {},
  data: function ()  {
    return {
      eventData: '',
      isLoading: false,
      dateChoosed: false,
      timeChoosed: false,
      availableTimeKey: 0,
      finalDateTime: new Date()
    }
  },
  created () {},
  components: {
    'available-date': AvailableDate,
    'available-time': AvailableTime,
  },
  methods: {
    forceRerender ()  {
      this.availableTimeKey += 1;
    },
    dateChanged (obj) {
      this.dateChoosed = obj[0]
      this.allDates = Object.values(obj[1])
      this.forceRerender()
    },
    timeChanged (obj) {
      this.timeChoosed = obj
      this.finalDateTime.setDate(this.dateChoosed.getDate())
      this.finalDateTime.setMonth(this.dateChoosed.getMonth())
      this.finalDateTime.setHours(this.timeChoosed.getHours())
      this.finalDateTime.setMinutes(this.timeChoosed.getMinutes())
      this.finalDateTime.setSeconds(0)
      this.$emit('eventDateTimeChanged', this.finalDateTime)
    }
  },
  computed: {}
}
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
</style>
